function [Rxx,Ryy,Rxy,Rmax] = cor(x,lag)
% ----------------------------------------------------
% USAGE :
%	[Rxx,Ryy,Rxy,Rmax] = cor(x,lag)
%
% DESCRIPTION :
%	֊֐̌vZ
%
% 	Rev.0.1;  11 Nov. 2004, coded by Hidekazu Kugemoto
%
% INPUT :
% 	x		:	nf[^PCnf[^Q
%   lag     :   O
%
% OUTPUT :
%	Rxx     :	f[^P̎ȑ֊֐[0:2*lag]
%	Ryy     :	f[^Q̎ȑ֊֐[0:2*lag]
%   Rxy     :   ݑ֊֐[-lag:lag]
%   Rmax    :   ֌WőƂȂ郉OA֌W
%	
%	Copyright (C) 2004-2011 JSPS PSE143 WS25, Japan.
%	All rights reserved. 
%	{vOі{vOύXvO̍Ĕzzւ܂D
% ----------------------------------------------------
Rxx = [];   Ryy = [];   Rxy = [];
Rmax = zeros(2,1);
if isempty(x); return; end;		% ُ폈
[m n]=size(x);  t1=0:2*lag;   t2=-lag:lag;
if m < lag then return; end;
if n >= 1
    if std(x(:,1)) > 0.000001
        Rxx = xcorr(x(:,1)-mean(x(:,1)),2*lag,'coeff');
        Rxx = [t1' Rxx(2*lag+1:4*lag+1)];
    else
        Rxx = [t1' zeros(2*lag+1,1)];
    end
end
if n >= 2
    if std(x(:,2)) > 0.000001
        Ryy = xcorr(x(:,2)-mean(x(:,2)),2*lag,'coeff');
        Ryy = [t1' Ryy(2*lag+1:4*lag+1)];
    else
        Ryy = [t1' zeros(2*lag+1,1)];
    end
    if min(std(x(:,1:2))) > 0.000001
        Rxy = xcorr(x(:,1)-mean(x(:,1)),x(:,2)-mean(x(:,2)),lag,'coeff');
        Rmax(2) = max(abs(Rxy(lag+1:2*lag)));
        pos = find(abs(Rxy(lag+1:2*lag)) == Rmax(2));
        Rmax(1) = pos(1);
        Rxy = [t2' Rxy];
    else
        Rxy = [t2' zeros(2*lag+1,1)];
    end
end
