function [clp,noise,coef] = cpi(PV,d,na,nc,ninp)
% ----------------------------------------------------
% USAGE :
%	[clp,noise,coef] = cpi(PV,d,na,nc,ninp)
%
% DESCRIPTION :
%	䐫\wW
%
% 	Rev.0.1;  10 Nov. 2004, coded by Hidekazu Kugemoto
%
% INPUT :
% 	PV		:	ʂ̎nf[^
% 	d		:	䐫\wWvZނԕ
%   na      :   AR
%   nc      :   MA
%   ninp    :   CpX
%
% OUTPUT :
%	clp     :	䐫\wW[d+1]
%	noise	:	mCY[slength(PV)]
%   coef    :   CpX[ninp]
%	
%	Copyright (C) 2004-2011 JSPS PSE143 WS25, Japan.
%	All rights reserved. 
%	{vOі{vOύXvO̍Ĕzzւ܂D
% ----------------------------------------------------
clp = [];   noise = []; coef = [];
if isempty(PV); return; end;			% ُ폈
if std(PV)<0.000001; return; end;
d = max(d,10);  na = max(na,1); nc = max(nc,1);
n = length(PV);
data = PV-mean(PV);									% ϒl
model = armax(data,[na nc]);						% ARMAf̍쐬
noise = filter(model.a,model.c,data);				% FG̎Zo
coef = filter(model.c,model.a,[1 zeros(1,ninp-1)]);	% CpX̌vZ
clp = zeros(d+1,1);                                 % FCOR@ɂHaiss Index̌vZ 
stdy = std(data);
stda = std(noise);
for i=1:d
    YA = cov(data(i:n),noise(1:n-i+1));
    eta = YA(2,1)/stdy/stda;
    clp(i+1) = clp(i)+eta*eta;
end
