function [index,width] = kuge_chk(PV,MV)
% ----------------------------------------------------
% USAGE :
%	[index,width] = kuge_chk(PV,MV)
%
% DESCRIPTION :
%	Backlash֐pouXeBNVffiv{@j
%
% 	Rev.0.1;  11 Jul. 2003, coded by Hiroshi Maruta
%	Rev.1.0;   8 Nov. 2004, updated by Hidekazu Kugemoto
%
% INPUT :
% 	PV		:	ʂ̎nf[^
% 	MV		:	ʂ̎nf[^
%
% OUTPUT :
%	index	:	XeBbNCfbNXi0`1)
%				iouXeBNVNĂ銄j
%	width	:	XeBbN
%	
%	Copyright (C) 2003-2011 JSPS PSE143 WS25, Japan.
%	All rights reserved. 
%	{vOі{vOύXvO̍Ĕzzւ܂D
% ----------------------------------------------------
Fmin = 0;   Fmax = max(MV)-min(MV);
F0 = 0;     FminOld = 0;
F0min = 0;  F0max = 0;
count = 0;
rc=zeros(3,1);
if std(PV)<0.0001
    index = 1;    width = max(MV)-min(MV);
    return
end
if std(MV)<0.0001
    index = 0;    width = 0;
    return
end
while abs(Fmax-Fmin)>0.01
    if count>=20; break; end;
    rc(1) = abs(evalute(PV,MV,Fmin,F0));
    rc(2) = abs(evalute(PV,MV,(Fmin+Fmax)/2,F0));
    rc(3) = abs(evalute(PV,MV,Fmax,F0));
    FminOld = Fmin;
    if rc(1) == max(rc)
        Fmax = (Fmin+Fmax)/2;
    elseif rc(3) == max(rc)
        Fmin = (Fmin+Fmax)/2;
    else
        Fmin = (3*Fmin+Fmax)/4;
        Fmax = (Fmin+3*Fmax)/4;
    end
    F0max=F0max+Fmin-FminOld;
    rc(1) = abs(evalute(PV,MV,(Fmin+Fmax)/2,F0min));
    rc(2) = abs(evalute(PV,MV,(Fmin+Fmax)/2,(F0min+F0max)/2));
    rc(3) = abs(evalute(PV,MV,(Fmin+Fmax)/2,F0max));
    if rc(1) == max(rc)
        F0max = (F0min+F0max)/2;
    elseif rc(3) == max(rc)
        F0min = (F0min+F0max)/2;
    else
        F0min = (3*F0min+F0max)/4;
        F0max = (F0min+3*F0max)/4;
    end
    count = count+1;
end
width = (Fmin+Fmax)/2;
r = abs(evalute(PV,MV,Fmax,F0));
index = min(Fmax,1)*r;

function r = evalute(PV,MV,Fmax,F0)
% ----------------------------------------------------
% USAGE :
%	r = evalute(PV,MV,Fmax,F0)
%
% DESCRIPTION :
%	Backlash֐̃p[^]֐
%
% INPUT :
% 	PV		:	ʂ̎nf[^
% 	MV		:	ʂ̎nf[^
%   Fmax    :   XeBbN
%   F0      :   n_p
%
% OUTPUT :
%	r       :	֌Wi0`1)
% ----------------------------------------------------
F   = backlash(MV,Fmax,F0);
r1  = corrcoef(MV-F,PV);
r   = r1(1,2);

function F = backlash(MV,Fmax,F0)
% ----------------------------------------------------
% USAGE :
%	F = backlash(MV,Fmax,F0)
%
% DESCRIPTION :
%	Backlash֐
%         F(t) = max( min(F(t-1) + dMV(t), Fmax), 0);
%        dMV(t) = MV(t) - MV(t-1);
%
% INPUT :
% 	MV		:	ʂ̎nf[^
%   Fmax    :   XeBbN
%   F0      :   n_p
%
% OUTPUT :
%	F       :	o
% ----------------------------------------------------
deltaMV = diff(MV);
F = zeros(length(MV),1);
F(1) = F0;
for i=2:length(MV)
  F(i) = max([min([F(i-1) + deltaMV(i-1); Fmax]), 0]); 
end
