function [Pxx,Pyy,Pxy,cyc] = Spec(x)
% ----------------------------------------------------
% USAGE :
%	[Pxx,Pyy,Pxy,cyc] = Spec(x)
%
% DESCRIPTION :
%	p[XyNǧvZ
%
% 	Rev.0.1;  11 Nov. 2004, Hidekazu Kugemoto
%
% INPUT :
% 	x		:	nf[^PCnf[^Q
%
% OUTPUT :
%	Pxx     :	f[^P̃p[XyNg
%	Pyy     :	f[^Q̃p[XyNg
%   Pxy     :   NXXyNg
%   cyc     :   f[^PAf[^Q̎
%	
%	Copyright (C) 2004-2011 JSPS PSE143 WS25, Japan.
%	All rights reserved. 
%	{vOі{vOύXvO̍Ĕzzւ܂D
% ----------------------------------------------------
Pxx = [];   Pyy = [];   Pxy = [];
cyc = zeros(2,1);
if isempty(x); return; end;			% ُ폈
[m n]=size(x);
m=max(2*fix(m/2),2);    t=2:m/2;
if n >= 1
    X = fft((x(1:m,1)-mean(x(1:m,1)))/max(std(x(1:m,1)),0.000001));
    Pxx = X.*conj(X)/m;
    Pxx = [t'/m Pxx(t)];
    if max(Pxx(:,2)) > 10
        pos = find(Pxx(:,2) == max(Pxx(:,2)));
        cyc(1) = 1/Pxx(pos(1),1);
    end
end
if n >= 2
    Y = fft((x(1:m,2)-mean(x(1:m,2)))/max(std(x(1:m,2)),0.000001));
    Pyy = Y.*conj(Y)/m;
    Pyy = [t'/m Pyy(t)];
    Pxy = abs(conj(X).*Y/m);
    Pxy = [t'/m Pxy(t)];    
    if max(Pyy(:,2)) > 10
        pos = find(Pyy(:,2) == max(Pyy(:,2)));
        cyc(2) = 1/Pyy(pos(1),1);
    end
end
