function [index, width] = yama_chk(PV,MV)
% ----------------------------------------------------
% USAGE :
%	[index, width] = yamashita_chk(PV,MV)
%
% DESCRIPTION :
%	萫IMɂouXeBNVffiR@j
%
% 	Rev.0.1;   3 Nov. 2003, Yoshiyuki Yamashita
%	Rev.0.2;  17 Nov. 2004
%	Rev.0.9;  20 Jan. 2004
%	Rev.1.0;   5 Nov. 2004, Hidekazu Kugemoto
%
% INPUT :
% 	PV		:	ʂ̎nf[^
% 	MV		:	ʂ̎nf[^
%
% OUTPUT :
%	index	:	XeBbNCfbNXi0`1)
%				iouXeBNVNĂ銄j
%	width	:	XeBbN
%	
%	Copyright (C) 2003-2011 JSPS PSE143 WS25, Japan.
%	All rights reserved. 
%	{vOі{vOύXvO̍Ĕzzւ܂D
% ----------------------------------------------------
dPV = diff(PV);
dMV = diff(MV);
Pt = q_shape(quantize(dMV,std(dMV)), quantize(dPV,std(dPV)));
QT=q_trend(Pt);

% `Fp^[
T0 = trend_match(QT,4,-1);                              % pattern (SS)
T1 = trend_match(QT,7,8) + trend_match(QT,7,5);         % pattern (PS,PP),(PS,SP)
T1 = T1 + trend_match(QT,1,0) + trend_match(QT,1,3);    % pattern (MS,MM),(MS,SM)
T2 = trend_match(QT,7,2) + trend_match(QT,7,5);         % pattern (PS,MP),(PS,SP)
T2 = T2 + trend_match(QT,1,6) + trend_match(QT,1,3);    % pattern (MS,PM),(MS,SM)
index = max(T1,T2) / (length(dMV)-T0);

width = q_band(dMV,Pt);

function [Y] = q_trend(X)
% ------------------------------------------------------------
% USAGE :
%	[Y] = q_trend(X)
%
% DESCRIPTION :
%	gh`Wv֐
%
% INPUT :
% 	X		:	gh`p^[xNg(p^[ԍ)
%
% OUTPUT :
% 	Y		:	gh`Wvsip^[ԍ,j
% ------------------------------------------------------------
k = 1;
t = 1;
n = length(X);
Y(1,1) = X(1);
for i=2:1:n
   if X(i) == Y(k,1)
      t = t + 1;
      if i == n
         Y(k,2) = t;
      end
   else
      Y(k,2) = t;
      k = k+1;
      Y(k,1) = X(i);
      t = 1;
   end
end
Y(k+1,1) = -1;	% I[q
Y(k+1,2) = 0;

function [P] = q_shape(X, Y)
% ------------------------------------------------------------
% USAGE :
%	[P] = q_shape(X,Y)
%
% DESCRIPTION :
%	gh`ϊ֐
% 	0: MM, 1: MS, 2: MP, 3: SM, 4: SS, 5: SP, 6: PM, 7: PS, 8: PP
%
% INPUT :
% 	X		:	MVUxNgi-1, 0 or 1)
% 	Y		:	PVUxNgi-1, 0 or 1)
%
% OUTPUT :
% 	P		:	gh`p^[xNgip^[ԍj
% ------------------------------------------------------------
P = 3*(X+1)+Y+1;

function [Y] = quantize(X, eps)
% ------------------------------------------------------------
% USAGE :
%	[Y] = quantize(X,eps)
%
% DESCRIPTION :
%	ghU֐
% 	-1: M, 0: S, 1: P
%
% INPUT :
% 	X		:	nf[^xNg
% 	eps		:	ωȂƌȂ臒l
%
% OUTPUT :
% 	Y		:	Uf[^
% ------------------------------------------------------------
for i=1:1:length(X)
  if abs(X(i)) < eps
    Y(i) = 0;
  else
    Y(i) = sign(X(i));
  end
end

function n = trend_match(P, p1, p2)
% ------------------------------------------------------------
% USAGE :
%	n = trend_match(P,p1,p2)
%
% DESCRIPTION :
%	`p^[}b`O֐
%
% INPUT :
% 	P		:	gh`Wvsip^[ԍ,j
% 	p1		:	p^[P
% 	p2		:	p^[Q
%
% OUTPUT :
% 	n		:	p^[PɊY̍v
% ------------------------------------------------------------
n=0;
for i=1:length(P)
   if P(i,1) == p1
      if p2 < 0 | P(i+1,1) == p2
         n = n+P(i,2);
      end
   end
end

function width = q_band(dMV,P)
% ------------------------------------------------------------
% USAGE :
%	width = q_band(dMV,P)
%
% DESCRIPTION :
%	XeBbNԃJEg֐
%
% INPUT :
% 	dMV	:	ʂ̕ωxNg
% 	P		:	gh`p^[xNgip^[ԍj
%
% OUTPUT :
% 	width	:	XeBbNԍvl
% ------------------------------------------------------------
n=0;
stick = 0;
band = 0;
flag = 0;
for i=1:1:length(P)
   if P(i) == 7 | P(i) == 1
      if flag == 0
         n = n+1;   flag = 1;
      end     
      if i == length(P); stick = stick+abs(band); end;
      band = band+dMV(i);
   elseif P(i) == 4
      band = band+dMV(i);
   else
      if flag == 1
         stick = stick+abs(band);
      end
      flag = 0;
      band = 0;
   end
   width = stick/max(n,1);
end
